Index: /trunk/SophyaProg/Tests/smakefile
===================================================================
--- /trunk/SophyaProg/Tests/smakefile	(revision 3571)
+++ /trunk/SophyaProg/Tests/smakefile	(revision 3572)
@@ -1,4 +1,3 @@
 include $(SOPHYABASE)/include/sophyamake.inc
-
  
 PROGS = $(SOPHYAEXEP)arrt $(SOPHYAEXEP)carrt $(SOPHYAEXEP)lpk $(SOPHYAEXEP)obj_fits $(SOPHYAEXEP)ovharr $(SOPHYAEXEP)pizthr $(SOPHYAEXEP)ppftswap $(SOPHYAEXEP)spar $(SOPHYAEXEP)sphg0 $(SOPHYAEXEP)sph2lm $(SOPHYAEXEP)tcmd $(SOPHYAEXEP)tcxxcmpldynl $(SOPHYAEXEP)tdcr $(SOPHYAEXEP)tdynl $(SOPHYAEXEP)tfft $(SOPHYAEXEP)thash $(SOPHYAEXEP)timg $(SOPHYAEXEP)tmxv $(SOPHYAEXEP)tnt $(SOPHYAEXEP)tobjio2 $(SOPHYAEXEP)tobjio $(SOPHYAEXEP)tpipe $(SOPHYAEXEP)tsimplex $(SOPHYAEXEP)tsphereecp $(SOPHYAEXEP)tspm2 $(SOPHYAEXEP)tspm $(SOPHYAEXEP)tstboloread $(SOPHYAEXEP)tstcolread $(SOPHYAEXEP)tstdtable $(SOPHYAEXEP)tstndblk $(SOPHYAEXEP)tstppfwrapstl $(SOPHYAEXEP)tstsegdb $(SOPHYAEXEP)tswfits $(SOPHYAEXEP)tnfits $(SOPHYAEXEP)tfitsdt $(SOPHYAEXEP)tsttmat $(SOPHYAEXEP)tsttminv $(SOPHYAEXEP)tsttvec $(SOPHYAEXEP)ttimestamp $(SOPHYAEXEP)zthr $(SOPHYAEXEP)tmtrnd $(SOPHYAEXEP)tmtrnd3 $(SOPHYAEXEP)tmtdt
@@ -229,4 +228,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -252,4 +252,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  arrt.cc
@@ -259,4 +260,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -282,4 +284,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  carrt.cc
@@ -288,4 +291,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -313,10 +317,10 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)intflapack.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  lpk.cc
  
-$(SOPHYAOBJP)obj_fits.o: obj_fits.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)obj_fits.o: obj_fits.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -337,6 +341,7 @@
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)xntuple.h \
-  $(SOPHYAINCP)fitsxntuple.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)fitsntuple.h \
+  $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)fitsfile.h \
   $(SOPHYAINCP)ndatablock.h \
@@ -345,5 +350,4 @@
   $(SOPHYAINCP)FitsIO/longnam.h \
   $(SOPHYAINCP)fitshandler.h \
-  $(SOPHYAINCP)fitsntuple.h \
   $(SOPHYAINCP)fitstarray.h \
   $(SOPHYAINCP)tarray.h \
@@ -357,5 +361,6 @@
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)sopemtx.h
+  $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  obj_fits.cc
  
@@ -364,4 +369,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -387,4 +393,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)ctimer.h \
   $(SOPHYAINCP)timing.h \
@@ -395,4 +402,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)pisysdep.h \
@@ -400,4 +408,5 @@
   $(SOPHYAINCP)piapplgen.h \
   $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)pisysdep.h \
   $(SOPHYAINCP)picontainerx.h \
   $(SOPHYAINCP)picontainergen.h \
@@ -405,11 +414,19 @@
   $(SOPHYAINCP)piwdggen.h \
   $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pipixutils.h \
   $(SOPHYAINCP)pimenubarx.h \
   $(SOPHYAINCP)pimenubargen.h \
   $(SOPHYAINCP)pimenux.h \
   $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)piconsenum.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
   $(SOPHYAINCP)picons.h \
   $(SOPHYAINCP)pistdwdgx.h \
-  $(SOPHYAINCP)pistdwdggen.h \
   $(SOPHYAINCP)pibwdgx.h \
   $(SOPHYAINCP)pibwdggen.h \
@@ -427,8 +444,4 @@
   $(SOPHYAINCP)psfile.h \
   $(SOPHYAINCP)pigraphps.h \
-  $(SOPHYAINCP)piwindowx.h \
-  $(SOPHYAINCP)piwindowgen.h \
-  $(SOPHYAINCP)piperiodx.h \
-  $(SOPHYAINCP)periodic.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -455,9 +468,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  pizthr.cc
  
-$(SOPHYAOBJP)ppftswap.o: ppftswap.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)ppftswap.o: ppftswap.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)sophyainit.h \
   $(SOPHYAINCP)machdefs.h \
@@ -485,6 +498,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)fiondblock.h \
-  $(SOPHYAINCP)tarrinit.h
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ppftswap.cc
  
@@ -493,4 +509,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -516,4 +533,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)resusage.h
@@ -539,4 +557,5 @@
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
@@ -617,4 +636,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)cexpre.h \
@@ -666,4 +686,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)cxxcmplnk.h \
   $(SOPHYAINCP)pdlmgr.h \
@@ -702,5 +723,7 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)psighand.h \
+  $(SOPHYAINCP)fmath.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tdcr.cc
@@ -733,5 +756,7 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tdynl.cc
@@ -740,4 +765,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)tarray.h \
@@ -803,4 +829,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitsinoutfile.h \
@@ -820,5 +847,6 @@
   $(SOPHYAINCP)ppfbinstream.h \
   $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  thash.cc
  
@@ -851,6 +879,8 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)cimage.h \
   $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)ndatablock.h \
   $(SOPHYAINCP)fiondblock.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  timg.cc
@@ -883,4 +913,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)tarrinit.h \
@@ -901,10 +932,47 @@
   $(SOPHYAINCP)swfitsdtable.h \
   $(SOPHYAINCP)fitsswapper.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)fitsblkrw.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)histinit.h \
-  $(SOPHYAINCP)ntoolsinit.h
+  $(SOPHYAINCP)ntoolsinit.h \
+  $(SOPHYAINCP)tarrinit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtdt.cc
+ 
+$(SOPHYAOBJP)tmtrnd.o: tmtrnd.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)resusage.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)matharr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd.cc
  
 $(SOPHYAOBJP)tmtrnd3.o: tmtrnd3.cc $(SOPHYAINCP)sopnamsp.h \
@@ -932,4 +1000,5 @@
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -940,40 +1009,8 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd3.cc
  
-$(SOPHYAOBJP)tmtrnd.o: tmtrnd.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)zthread.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)resusage.h \
-  $(SOPHYAINCP)ctimer.h \
-  $(SOPHYAINCP)timing.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)fioarr.h \
-  $(SOPHYAINCP)matharr.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+$(SOPHYAOBJP)tmxv.o: tmxv.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)stsrand.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmtrnd.cc
- 
-$(SOPHYAOBJP)tmxv.o: tmxv.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
@@ -998,4 +1035,5 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)tvector.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmxv.cc
@@ -1008,4 +1046,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)tarray.h \
@@ -1031,10 +1070,13 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
   $(SOPHYAINCP)fitsblkrw.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
   $(SOPHYAINCP)fitsarrhand.h \
   $(SOPHYAINCP)fitshandler.h \
+  $(SOPHYAINCP)fitsblkrw.h \
   $(SOPHYAINCP)fiosinit.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tnfits.cc
@@ -1059,5 +1101,5 @@
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)xntuple.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)datatable.h \
   $(SOPHYAINCP)basedtable.h \
@@ -1078,5 +1120,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tnt.cc
  
-$(SOPHYAOBJP)tobjio2.o: tobjio2.cc $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tobjio.o: tobjio.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1109,10 +1151,13 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)srandgen.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio2.cc
- 
-$(SOPHYAOBJP)tobjio.o: tobjio.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)fioarr.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio.cc
+ 
+$(SOPHYAOBJP)tobjio2.o: tobjio2.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1145,9 +1190,11 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)histos2.h \
+  $(SOPHYAINCP)histos.h \
   $(SOPHYAINCP)ntuple.h \
   $(SOPHYAINCP)ntupintf.h \
-  $(SOPHYAINCP)srandgen.h \
-  $(SOPHYAINCP)fioarr.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio.cc
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)srandgen.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tobjio2.cc
  
 $(SOPHYAOBJP)tpipe.o: tpipe.cc $(SOPHYAINCP)sopnamsp.h \
@@ -1158,6 +1205,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tpipe.cc
  
-$(SOPHYAOBJP)tsimplex.o: tsimplex.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tsimplex.o: tsimplex.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)simplex.h \
   $(SOPHYAINCP)machdefs.h \
@@ -1194,4 +1240,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsimplex.cc
@@ -1207,4 +1254,5 @@
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)resusage.h \
   $(SOPHYAINCP)sphereecp.h \
   $(SOPHYAINCP)sphericalmap.h \
@@ -1212,4 +1260,5 @@
   $(SOPHYAINCP)pixelmap.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1236,11 +1285,13 @@
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)fiosphereecp.h \
+  $(SOPHYAINCP)sphereecp.h \
   $(SOPHYAINCP)array.h \
   $(SOPHYAINCP)matharr.h \
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)samba.h \
   $(SOPHYAINCP)alm.h \
-  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)nbmath.h \
   $(SOPHYAINCP)triangmtx.h \
@@ -1258,4 +1309,51 @@
   $(SOPHYAINCP)tod.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsphereecp.cc
+ 
+$(SOPHYAOBJP)tspm.o: tspm.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)skymapinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)skymap.h \
+  $(SOPHYAINCP)spherethetaphi.h \
+  $(SOPHYAINCP)sphericalmap.h \
+  $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)pixelmap.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)spherepos.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)spherehealpix.h \
+  $(SOPHYAINCP)HEALPixUtils.h \
+  $(SOPHYAINCP)localmap.h \
+  $(SOPHYAINCP)sphereecp.h \
+  $(SOPHYAINCP)fiospherethetaphi.h \
+  $(SOPHYAINCP)fiospherehealpix.h \
+  $(SOPHYAINCP)fiolocalmap.h \
+  $(SOPHYAINCP)fiosphereecp.h \
+  $(SOPHYAINCP)tod.h \
+  $(SOPHYAINCP)misstime.h \
+  $(SOPHYAINCP)timing.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm.cc
  
 $(SOPHYAOBJP)tspm2.o: tspm2.cc $(SOPHYAINCP)sopnamsp.h \
@@ -1317,55 +1415,9 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm2.cc
  
-$(SOPHYAOBJP)tspm.o: tspm.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)skymapinit.h \
-  $(SOPHYAINCP)sophyainit.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)skymap.h \
-  $(SOPHYAINCP)spherethetaphi.h \
-  $(SOPHYAINCP)sphericalmap.h \
-  $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)pixelmap.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)spherepos.h \
-  $(SOPHYAINCP)unitvector.h \
-  $(SOPHYAINCP)vector3d.h \
-  $(SOPHYAINCP)longlat.h \
-  $(SOPHYAINCP)utilgeom.h \
-  $(SOPHYAINCP)datatype.h \
-  $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)spherehealpix.h \
-  $(SOPHYAINCP)HEALPixUtils.h \
-  $(SOPHYAINCP)localmap.h \
-  $(SOPHYAINCP)sphereecp.h \
-  $(SOPHYAINCP)fiospherethetaphi.h \
-  $(SOPHYAINCP)fiospherehealpix.h \
-  $(SOPHYAINCP)fiolocalmap.h \
-  $(SOPHYAINCP)fiosphereecp.h \
-  $(SOPHYAINCP)tod.h \
-  $(SOPHYAINCP)misstime.h \
-  $(SOPHYAINCP)timing.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tspm.cc
- 
 $(SOPHYAOBJP)tstboloread.o: tstboloread.cc \
   $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fboloread.h \
@@ -1379,4 +1431,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1398,4 +1451,5 @@
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fabtcolread.h \
@@ -1409,4 +1463,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1423,6 +1478,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstcolread.cc
  
-$(SOPHYAOBJP)tstdtable.o: tstdtable.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tstdtable.o: tstdtable.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)histinit.h \
   $(SOPHYAINCP)ntoolsinit.h \
@@ -1461,10 +1515,10 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstdtable.cc
  
-$(SOPHYAOBJP)tstndblk.o: tstndblk.cc \
-  $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)ntoolsinit.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+$(SOPHYAOBJP)tstndblk.o: tstndblk.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ntoolsinit.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ndatablock.h \
@@ -1480,8 +1534,10 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ppfwrapstlv.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1490,6 +1546,5 @@
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstppfwrapstl.cc
  
-$(SOPHYAOBJP)tstsegdb.o: tstsegdb.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tstsegdb.o: tstsegdb.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
@@ -1498,8 +1553,10 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)segdatablock.h \
   $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)thsafeop.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)fiosegdb.h \
   $(SOPHYAINCP)ppersist.h \
@@ -1508,7 +1565,9 @@
   $(SOPHYAINCP)rawstream.h \
   $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)segdatablock.h \
   $(SOPHYAINCP)ppftpointerio.h \
   $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppfswapper.h \
+  $(SOPHYAINCP)swsegdb.h \
   $(SOPHYAINCP)ppfwrapstlv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tstsegdb.cc
@@ -1519,4 +1578,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1528,4 +1588,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1542,9 +1603,9 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsttmat.cc
  
-$(SOPHYAOBJP)tsttminv.o: tsttminv.cc \
-  $(SOPHYAINCP)sopnamsp.h \
+$(SOPHYAOBJP)tsttminv.o: tsttminv.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)timing.h \
@@ -1552,4 +1613,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1561,4 +1623,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1575,4 +1638,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h \
   $(SOPHYAINCP)intflapack.h
@@ -1584,4 +1648,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)array.h \
@@ -1593,4 +1658,5 @@
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)gnumd5.h \
   $(SOPHYAINCP)ppfbinstream.h \
@@ -1607,4 +1673,5 @@
   $(SOPHYAINCP)fioarr.h \
   $(SOPHYAINCP)sopemtx.h \
+  $(SOPHYAINCP)arrctcast.h \
   $(SOPHYAINCP)srandgen.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tsttvec.cc
@@ -1632,4 +1699,5 @@
   $(SOPHYAINCP)thsafeop.h \
   $(SOPHYAINCP)fitsinoutfile.h \
+  $(SOPHYAINCP)dvlist.h \
   $(SOPHYAINCP)FitsIO/fitsio.h \
   $(SOPHYAINCP)FitsIO/longnam.h \
@@ -1647,7 +1715,9 @@
   $(SOPHYAINCP)fiosinit.h \
   $(SOPHYAINCP)swfitsdtable.h \
+  $(SOPHYAINCP)fitsswapper.h \
   $(SOPHYAINCP)fitshandler.h \
   $(SOPHYAINCP)datatable.h \
-  $(SOPHYAINCP)fitshdtable.h
+  $(SOPHYAINCP)fitshdtable.h \
+  $(SOPHYAINCP)datatable.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tswfits.cc
  
@@ -1657,4 +1727,5 @@
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h \
   $(SOPHYAINCP)objfio.h \
   $(SOPHYAINCP)anydataobj.h \
@@ -1669,4 +1740,5 @@
   $(SOPHYAINCP)tarrinit.h \
   $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)ppfwrapstlv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  ttimestamp.cc
@@ -1694,8 +1766,10 @@
   $(SOPHYAINCP)tmatrix_tsnl.h \
   $(SOPHYAINCP)tvector.h \
-  $(SOPHYAINCP)tvector_tsnl.h \
-  $(SOPHYAINCP)matharr.h \
-  $(SOPHYAINCP)tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)matharr.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)stsrand.h \
   $(SOPHYAINCP)timing.h \
   $(SOPHYAINCP)ctimer.h
Index: /trunk/SophyaProg/Tests/tfft.cc
===================================================================
--- /trunk/SophyaProg/Tests/tfft.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tfft.cc	(revision 3572)
@@ -187,5 +187,5 @@
 
   ndiff = 0;
-  maxdif=0., vdif;
+  maxdif=0.;
   for(i=0; i<num; i++) {
     vdif = fabs(module(difc(i)));
Index: /trunk/SophyaProg/Tests/thash.cc
===================================================================
--- /trunk/SophyaProg/Tests/thash.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/thash.cc	(revision 3572)
@@ -8,5 +8,5 @@
 int main(int narg, char *arg[])
 {
-  char * sid[3] = { "Hello","Reza","ERIC" } ;
+  const char * sid[3] = { "Hello","Reza","ERIC" } ;
   uint_8 code[3];
   int k;
Index: /trunk/SophyaProg/Tests/tmtdt.cc
===================================================================
--- /trunk/SophyaProg/Tests/tmtdt.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tmtdt.cc	(revision 3572)
@@ -193,5 +193,5 @@
   }
 #endif
-  char* nomnt[5]={"tid","k","x","cx","sx"};
+  const char* nomnt[5]={"tid","k","x","cx","sx"};
   NTuple* nt = NULL;
   BaseDataTable* dt = NULL;
Index: /trunk/SophyaProg/Tests/tnt.cc
===================================================================
--- /trunk/SophyaProg/Tests/tnt.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tnt.cc	(revision 3572)
@@ -9,5 +9,4 @@
 #include "dvlist.h"
 #include "ntuple.h"
-#include "xntuple.h"
 #include "datatable.h"
 #include "swppfdtable.h"
@@ -19,6 +18,4 @@
 void test_dvl();
 void test_ntuple();
-void test_xntuple() ; 
-void test_Xntuple() ; 
 void test_DataTable() ; 
 void test_SwPPFDataTable() ; 
@@ -28,6 +25,6 @@
   SophyaInit();
   if (narg < 2) {
-    cout << " tnt/Erreur arg - Usage: tnt d/n/x/X/DT/SWDT \n" 
-	 << " d:DVList n:NTuple x/X:XNTuple DT,SWDT: SwPPF/DataTable test \n" << endl;
+    cout << " tnt/Erreur arg - Usage: tnt d/n/DT/SWDT \n" 
+	 << " d:DVList n:NTuple DT,SWDT: SwPPF/DataTable test \n" << endl;
     exit(0);
   }
@@ -36,6 +33,4 @@
     if (*arg[1] == 'd')  test_dvl();
     else if (*arg[1] == 'n')  test_ntuple();
-    else if (*arg[1] == 'x')  test_xntuple();
-    else if (*arg[1] == 'X')  test_Xntuple();
     else if (strcmp(arg[1],"DT") == 0)  test_DataTable();
     else if (strcmp(arg[1],"SWDT") == 0)  test_SwPPFDataTable();
@@ -59,5 +54,5 @@
 void test_ntuple()
 {
-  char * names[3] = {"XPos", "YPos", "Val"};
+  const char * names[3] = {"XPos", "YPos", "Val"};
   int i,j, k;
   float xnt[3];
@@ -424,112 +419,2 @@
 
 
-void test_Xntuple() 
-{
-    char* names[] = {"str1", "str2", "str3", "str4", "str5"} ; 
-    XNTuple nt(0, 0, 0, 5, names) ; 
-    char** ce = new char*[5] ; 
-    int i;
-    for(i = 0 ; i < 5 ; i++)
-	ce[i] = new char[20] ; 
-
-  cout << "======= test_Xtuple:  simple XNTuple test ======= " << endl;
-
-    strncpy(ce[1], "toto a une auto", 20) ; 
-    strncpy(ce[2], "titi a une iti", 20) ; 
-    strncpy(ce[3], "tutu a une utu", 20) ; 
-    strncpy(ce[4], "tata a une ata", 20) ; 
-    for(i = 0 ; i < 100000 ; i++) {
-	sprintf(ce[0], "%d", i) ; 
-	nt.Fill(NULL, NULL, NULL, ce) ; 
-    }
-    
-    nt.Show() ; 
-    cout << nt.LineHeaderToString() ; 
-    cout << nt.LineToString(5027) << endl ; 
-    
-    char* names2[] = {"d0", "d1", "f0", "f1", "f2", "i0", "str0", "str1"} ; 
-    XNTuple nt2(2, 3, 1, 2, names2) ; 
-    double de[2] ; float fe[3] ; int ie ; 
-    char** ce2 = new char*[2] ; 
-    for(i = 0 ; i < 2 ; i++) ce2[i] = new char[20] ; 
-    strncpy(ce2[1], "glop glop", 20) ; 
-    
-    for(i = 0 ; i < 100000 ; i++) {
-	de[0] = i ; 
-	de[1] = sin((double)i) ; 
-	fe[0] = i ; 
-	fe[1] = i * cos((double)i) ; 
-	fe[2] = 2*i ; 
-	ie    = -i; 
-	sprintf(ce[0], "%d", i) ; 
-	nt2.Fill(de, fe, &ie, ce) ; 
-    }
-    nt2.Show() ; 
-    nt2.LineHeaderToString() ; 
-    //    nt2.LineToString(20) ; 
-}
-
-
-void test_xntuple() 
-{
-    char* names[] = {"dblval", "floval", "intval", "strval"} ; 
-    XNTuple nt(1, 1, 1, 1, names) ; 
-    double de ; 
-    float  fe ; 
-    int    ie ; 
-    char*  ce = new char[22] ; 
-    
-    
-  cout << "======= test_Xtuple:  XNTuple test ======= " << endl;
-  int i;
-    for(i = 0 ; i < nt.NVar() ; i++)
-	printf(" +++ %s <--> %d \n", 
-	       nt.NomIndex(i).c_str(), nt.IndexNom(nt.NomIndex(i).c_str())) ; 
-
-    for(i = 0 ; i < 100000 ; i++) {
-	de = fe = ie = i ; 
-	sprintf(ce, "%d", i) ; 
-	nt.Fill(&de, &fe, &ie, &ce) ; 
-    }
-    nt.Show() ; 
-    cout << nt.VarList_C("toto") ; 
-    cout << nt.LineHeaderToString() ; 
-    cout << nt.LineToString(20) << endl << endl ; 
-    
-    
-    XNTuple nt2 ; 
-    nt2.SwapPath() = "/tmp/sop/" ; 
-    nt2.Copy(nt) ; 
-    nt2.Show() ; 
-    for(i = 0 ; i < 100000 ; i++) {
-	de = fe = ie = i ; 
-	sprintf(ce, "%d", i) ; 
-	nt2.Fill(&de, &fe, &ie, &ce) ; 
-    }
-    nt2.Show() ; 
-    
-    {
-      POutPersist os("xnt.ppf");
-      os << nt2 ;
-    }
-
-    XNTuple::SetSwapPath("/tmp/sop/") ; 
-    XNTuple nt3("xnt.ppf") ; 
-    nt3.Show() ; 
-    
-    for(i = 0 ; i < nt3.NEntry() ; i+= 1000)
-	printf("%f %f %d %s\n", 
-	       nt3.GetDVal(i,0), 
-	       nt3.GetFVal(i,1), 
-	       nt3.GetIVal(i,2), 
-	       nt3.GetSVal(i,3).c_str()) ; 
-    
-    double min, max ; 
-    for(i = 0 ; i < nt3.NVar() ; i++) {
-	nt3.GetMinMax(i, min, max) ; 
-	printf("GetMinMax(%s) : %f/%f\n", 
-	       nt3.NomIndex(i).c_str(), min, max) ; 
-    }
-    //    nt3.Show() ; 
-}
-
Index: /trunk/SophyaProg/Tests/tobjio.cc
===================================================================
--- /trunk/SophyaProg/Tests/tobjio.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tobjio.cc	(revision 3572)
@@ -31,5 +31,5 @@
   NTuple *nt;
   float xnt[4];
-  char *ntn[4] = {"x","y","ex","ey"};
+  const char *ntn[4] = {"x","y","ex","ey"};
   int nent,i;
   nent = 1000;
@@ -117,5 +117,5 @@
   float xnt[6];
   double ang;
-  char *ntn[6] = {"x","y","z","ex","ey","ez"};
+  const char *ntn[6] = {"x","y","z","ex","ey","ez"};
   int nent,i;
       
Index: /trunk/SophyaProg/Tests/tobjio2.cc
===================================================================
--- /trunk/SophyaProg/Tests/tobjio2.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tobjio2.cc	(revision 3572)
@@ -32,5 +32,5 @@
   NTuple *nt;
   float xnt[4];
-  char *ntn[4] = {"x","y","ex","ey"};
+  const char *ntn[4] = {"x","y","ex","ey"};
   int nent,i;
   nent = 1000;
Index: /trunk/SophyaProg/Tests/tpipe.cc
===================================================================
--- /trunk/SophyaProg/Tests/tpipe.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tpipe.cc	(revision 3572)
@@ -93,5 +93,5 @@
   else {
     cout << ">> tpipe: fork() - creation de process ... " << endl;
-    char * zzz = "toto";
+    char zzz[32]; strcpy(zzz,"toto");
     pid_t rcf = fork();
     if (rcf == 0) {
Index: /trunk/SophyaProg/Tests/tspm2.cc
===================================================================
--- /trunk/SophyaProg/Tests/tspm2.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tspm2.cc	(revision 3572)
@@ -179,6 +179,6 @@
     {
       sphc.PixThetaPhi(j,teta,phi);
-      if (teta < 0.3)   sphc(j) = (30., drandpm1()*3.); 
-      else if ((teta>1.4) && (teta<1.6) ) sphc(j) = (20., NorRand()); 
+      if (teta < 0.3)   sphc(j) = complex<float>(30., drandpm1()*3.); 
+      else if ((teta>1.4) && (teta<1.6) ) sphc(j) = complex<float>(20., NorRand()); 
       else {
         if (phi < 2.)     sphc(j) = 2.; 
Index: /trunk/SophyaProg/Tests/tstboloread.cc
===================================================================
--- /trunk/SophyaProg/Tests/tstboloread.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tstboloread.cc	(revision 3572)
@@ -29,8 +29,8 @@
 {
  SophyaInit();
- char *label_alpha = "", *label_delta = "",
+ const char *label_alpha = "", *label_delta = "",
       *label_bolo  = "", *label_flag  = "",
       *label_snum  = "";
- char *fits_alpha  = "", *fits_delta  = "",
+ const char *fits_alpha  = "", *fits_delta  = "",
       *fits_bolo   = "", *fits_flag   = "",
       *fits_snum   = "";
Index: /trunk/SophyaProg/Tests/tstcolread.cc
===================================================================
--- /trunk/SophyaProg/Tests/tstcolread.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tstcolread.cc	(revision 3572)
@@ -21,5 +21,5 @@
 {
  SophyaInit();
- char *colname = "";
+ const char *colname = "";
  int colnum = -1;
  int ihdu = 0;
Index: /trunk/SophyaProg/Tests/tstppfwrapstl.cc
===================================================================
--- /trunk/SophyaProg/Tests/tstppfwrapstl.cc	(revision 3571)
+++ /trunk/SophyaProg/Tests/tstppfwrapstl.cc	(revision 3572)
@@ -39,5 +39,5 @@
     for(int k=0; k<SZV; k++) vw[k] = 3.141596*k;
     #define MyNSC 6 
-    char * strcst[MyNSC] = { "Langage C++" , "Programmation Objet", "Calcul scientifique",
+    const char * strcst[MyNSC] = { "Langage C++" , "Programmation Objet", "Calcul scientifique",
 			   "Librairie de classes", "SOPHYA", " et Java alors ?"};
 
